﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Collections;

namespace LSystems
{
    internal static class ExtensionMethods
    {
        public static List<object> AsList(this object obj)
        {
            if (obj is IEnumerable)
            {
                return (from object o in (obj as IEnumerable) select o).ToList();
            }
            else
            {
                return new List<object>() { obj };
            }
        }

        public static IEnumerable<Type> GetTypesSequence(this List<object> list, int index, int count)
        {
            for (int i = 0; i < count; ++i)
            {
                yield return list[index + i].GetType();
            }
        }

        public static IEnumerable<object> GetSequence(this List<object> list, int index, int count)
        {
            for (int i = 0; i < count; ++i)
            {
                yield return list[index + i];
            }
        }
    }
}
