﻿using System.Collections.Generic;
using System.Reflection;
using System;
using System.Linq;

namespace LSystems
{
    public class SystemBuilder
    {
        public static System BuildSystem(object systemDefinition)
        {
            var rules = new List<ProductionRule>();
            var systemDefinitionType = systemDefinition.GetType();

            foreach (var method in systemDefinitionType.GetMethods())
            {
                var rule = ProductionRule.GenerateRule(method);
                    
                if (rule != null)
                {
                    rules.Add(rule);
                }                
            }

            return new System(rules, systemDefinition);
        }        
    }
}